Apache Struts API Documentation: Class DispatchAction

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts.actions
Class DispatchAction

    java.lang.Object
      |
      +--org.apache.struts.action.Action
            |
            +--org.apache.struts.actions.DispatchAction

public abstract class DispatchAction
extends Action

An abstract Action that dispatches to a public method that is named by the request parameter whose name is specified by the `parameter` property of the corresponding ActionMapping. This Action is useful for developers who prefer to combine many similar actions into a single Action class, in order to simplify their application design.

To configure the use of this action in your `struts-config.xml` file, create an entry like this:

`<action path="/saveSubscription" type="org.apache.struts.actions.DispatchAction" name="subscriptionForm" scope="request" input="/subscription.jsp" parameter="method"/>`

which will use the value of the request parameter named "method" to pick the appropriate "perform" method, which must have the same signature (other than method name) of the standard Action.perform() method. For example, you might have the following three methods in the same action:

- public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
- public ActionForward insert(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
- public ActionForward update(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException

and call one of the methods with a URL like this:

`http://localhost:8080/myapp/saveSubscription.do?method=update`

NOTE - All of the other mapping characteristics of this action must be shared by the various handlers. This places some constraints over what types of handlers may reasonably be packaged into the same `DispatchAction` subclass.

Version:
  $Revision: 1.1 $ $Date: 2001-09-17 21:13:30 +0100 (Mon, 17 Sep 2001) $
Author:
  Niall Pemberton , Craig R. McClanahan

Field Summary
`protected java.lang.Class` | `clazz` The Class instance of this `DispatchAction` class.
`protected static MessageResources` | `messages` The message resources for this package.
`protected java.util.HashMap` | `methods` The set of Method objects we have introspected for this class, keyed by method name.
`protected java.lang.Class[]` | `types` The set of argument type classes for the reflected method call.

Fields inherited from class org.apache.struts.action.Action
`DATA_SOURCE_KEY, defaultLocale, ERROR_KEY, EXCEPTION_KEY, FORM_BEANS_KEY, FORWARDS_KEY, LOCALE_KEY, MAPPING_KEY, MAPPINGS_KEY, MESSAGES_KEY, MULTIPART_KEY, servlet, SERVLET_KEY, TRANSACTION_TOKEN_KEY`

Constructor Summary
`DispatchAction()`

Method Summary
`protected java.lang.reflect.Method` | `getMethod(java.lang.String name)` Introspect the current class to identify a method of the specified name that accepts the same parameter types as the `perform()` method does.
`ActionForward` | `perform(ActionMapping mapping, ActionForm form, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Process the specified HTTP request, and create the corresponding HTTP response (or forward to another web component that will create it).

Methods inherited from class org.apache.struts.action.Action
`generateToken, getLocale, getResources, getServlet, isCancelled, isTokenValid, perform, perform, perform, resetToken, saveErrors, saveToken, setLocale, setServlet, toHex`

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### clazz

    protected java.lang.Class clazz

  The Class instance of this `DispatchAction` class.

### messages

    protected static MessageResources messages

  The message resources for this package.

### methods

    protected java.util.HashMap methods

  The set of Method objects we have introspected for this class, keyed by method name. This collection is populated as different methods are called, so that introspection needs to occur only once per method name.

### types

    protected java.lang.Class[] types

  The set of argument type classes for the reflected method call. These are the same for all calls, so calculate them only once.

Constructor Detail

### DispatchAction

    public DispatchAction()

Method Detail

### perform

    public ActionForward perform(ActionMapping mapping,
                                 ActionForm form,
                                 javax.servlet.http.HttpServletRequest request,
                                 javax.servlet.http.HttpServletResponse response)
                          throws java.io.IOException,
                                 javax.servlet.ServletException

  Process the specified HTTP request, and create the corresponding HTTP response (or forward to another web component that will create it). Return an `ActionForward` instance describing where and how control should be forwarded, or `null` if the response has already been completed.
  Overrides:
    `perform` in class `Action`
  Parameters:
    `mapping` - The ActionMapping used to select this instance
    `actionForm` - The optional ActionForm bean for this request (if any)
    `request` - The HTTP request we are processing
    `response` - The HTTP response we are creating
  Throws:
    `java.io.IOException` - if an input/output error occurs
    `javax.servlet.ServletException` - if a servlet exception occurs

### getMethod

    protected java.lang.reflect.Method getMethod(java.lang.String name)
                                          throws java.lang.NoSuchMethodException

  Introspect the current class to identify a method of the specified name that accepts the same parameter types as the `perform()` method does.
  Parameters:
    `name` - Name of the method to be introspected
  Throws:
    `java.lang.NoSuchMethodException` - if no such method can be found

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2001 - Apache Software Foundation